Index: /trunk/sources/HeuristicLab.GP/3.3/GeneticProgrammingModel.cs
===================================================================
--- /trunk/sources/HeuristicLab.GP/3.3/GeneticProgrammingModel.cs	(revision 2222)
+++ /trunk/sources/HeuristicLab.GP/3.3/GeneticProgrammingModel.cs	(revision 2222)
@@ -0,0 +1,101 @@
+#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Text;
+using HeuristicLab.Core;
+using HeuristicLab.GP.Interfaces;
+using System.Xml;
+
+namespace HeuristicLab.GP {
+  public class GeneticProgrammingModel : ItemBase, IGeneticProgrammingModel {
+    private IFunctionTree functionTree;
+    public IFunctionTree FunctionTree {
+      get {
+        return functionTree;
+      }
+      set {
+        functionTree = value;
+        Size = functionTree.GetSize();
+        Height = functionTree.GetHeight();
+      }
+    }
+    public int Size { get; set; }
+    public int Height { get; set; }
+
+    public GeneticProgrammingModel()
+      : base() {
+    }
+
+    public GeneticProgrammingModel(IFunctionTree tree) : base() {
+      FunctionTree = tree;
+    }
+
+    public override object Clone(IDictionary<Guid, object> clonedObjects) {
+      GeneticProgrammingModel clone = (GeneticProgrammingModel)base.Clone(clonedObjects);
+      clone.FunctionTree = (IFunctionTree)FunctionTree.Clone();
+      return clone;
+    }
+
+    public override XmlNode GetXmlNode(string name, XmlDocument document, IDictionary<Guid, IStorable> persistedObjects) {
+      XmlNode node = base.GetXmlNode(name, document, persistedObjects);
+      PersistTree(node, document, persistedObjects, FunctionTree);
+      return node;
+    }
+
+    private void PersistTree(XmlNode node, XmlDocument document, IDictionary<Guid, IStorable> persistedObjects, IFunctionTree tree) {
+      XmlNode fNode = PersistenceManager.Persist(tree.Function, document, persistedObjects);
+      XmlAttribute subTreesAttr = document.CreateAttribute("Args");
+      subTreesAttr.Value = XmlConvert.ToString(tree.SubTrees.Count);
+      fNode.Attributes.Append(subTreesAttr);
+      node.AppendChild(fNode);
+      XmlNode treeNode = tree.GetXmlNode("Data", document, persistedObjects);
+      if (treeNode != null) fNode.AppendChild(treeNode);
+      foreach (IFunctionTree subTree in tree.SubTrees) {
+        PersistTree(node, document, persistedObjects, subTree);
+      }
+    }
+
+    public override void Populate(XmlNode node, IDictionary<Guid, IStorable> restoredObjects) {
+      base.Populate(node, restoredObjects);
+      int nodeIndex = 0;
+      FunctionTree = RestoreTree(node, ref nodeIndex, restoredObjects);
+    }
+
+    private IFunctionTree RestoreTree(XmlNode node, ref int nodeIndex, IDictionary<Guid, IStorable> restoredObjects) {
+      XmlNode fNode = node.ChildNodes[nodeIndex];
+      int subTrees = XmlConvert.ToInt32(fNode.Attributes["Args"].Value);
+      IFunction f = (IFunction)PersistenceManager.Restore(fNode, restoredObjects);
+      IFunctionTree tree = f.GetTreeNode();
+      if(fNode.ChildNodes.Count>0) tree.Populate(fNode.ChildNodes[0], restoredObjects);
+      nodeIndex++;
+      for (int i = 0; i < subTrees; i++) {
+        tree.AddSubTree(RestoreTree(node, ref nodeIndex, restoredObjects));
+      }
+      return tree;
+    }
+
+    public override IView CreateView() {
+      return new FunctionTreeView(this.FunctionTree);
+    }
+  }
+}
Index: /trunk/sources/HeuristicLab.GP/3.3/HeuristicLab.GP-3.3.csproj
===================================================================
--- /trunk/sources/HeuristicLab.GP/3.3/HeuristicLab.GP-3.3.csproj	(revision 2221)
+++ /trunk/sources/HeuristicLab.GP/3.3/HeuristicLab.GP-3.3.csproj	(revision 2222)
@@ -82,69 +82,39 @@
   </ItemGroup>
   <ItemGroup>
-    <Compile Include="BakedFunctionTree.cs" />
-    <Compile Include="TrainingWindowSlider.cs" />
-    <Compile Include="DefaultFunctionTreeNameGenerator.cs" />
-    <Compile Include="EqualiserController.cs" />
-    <Compile Include="Logging\TreeArityAnalyser.cs" />
-    <Compile Include="OffspringEqualiser.cs" />
-    <Compile Include="Recombination\SizeConstrictedGPCrossoverBase.cs" />
-    <Compile Include="Recombination\GPCrossoverBase.cs" />
-    <Compile Include="Recombination\UniformCrossover.cs" />
-    <Compile Include="UnknownFunctionException.cs" />
-    <Compile Include="IFunctionTreeNameGenerator.cs" />
-    <Compile Include="IFunctionTreeExporter.cs" />
-    <Compile Include="FunctionBase.cs" />
-    <Compile Include="FunctionView.cs">
+    <Compile Include="BaseClasses\BinaryFunction.cs" />
+    <Compile Include="BaseClasses\FunctionLibraryInjectorBase.cs" />
+    <Compile Include="BaseClasses\TerminalTreeNode.cs" />
+    <Compile Include="BaseClasses\FunctionBase.cs" />
+    <Compile Include="BaseClasses\FunctionTreeBase.cs" />
+    <Compile Include="BaseClasses\Terminal.cs" />
+    <Compile Include="BaseClasses\UnaryFunction.cs" />
+    <Compile Include="FunctionLibrary.cs" />
+    <Compile Include="FunctionLibraryEditor.cs">
       <SubType>UserControl</SubType>
     </Compile>
-    <Compile Include="FunctionView.Designer.cs">
-      <DependentUpon>FunctionView.cs</DependentUpon>
+    <Compile Include="FunctionLibraryEditor.Designer.cs">
+      <DependentUpon>FunctionLibraryEditor.cs</DependentUpon>
     </Compile>
-    <Compile Include="GPOperatorGroup.cs" />
-    <Compile Include="GPOperatorLibrary.cs" />
-    <Compile Include="GPOperatorLibraryEditor.cs">
+    <Compile Include="FunctionTreeView.cs">
       <SubType>UserControl</SubType>
     </Compile>
-    <Compile Include="GPOperatorLibraryEditor.Designer.cs">
-      <DependentUpon>GPOperatorLibraryEditor.cs</DependentUpon>
+    <Compile Include="FunctionTreeView.Designer.cs">
+      <DependentUpon>FunctionTreeView.cs</DependentUpon>
     </Compile>
+    <Compile Include="GeneticProgrammingModel.cs" />
+    <Compile Include="DefaultFunctionTreeNameGenerator.cs" />
+    <Compile Include="UnknownFunctionException.cs" />
     <Compile Include="HeuristicLabGPPlugin.cs" />
-    <Compile Include="IFunction.cs" />
-    <Compile Include="IFunctionTree.cs" />
-    <Compile Include="Manipulation\ChangeNodeTypeManipulation.cs" />
-    <Compile Include="Manipulation\CutOutNodeManipulation.cs" />
-    <Compile Include="Manipulation\DeleteSubTreeManipulation.cs" />
-    <Compile Include="Manipulation\FullTreeShaker.cs" />
-    <Compile Include="Manipulation\OnePointShaker.cs" />
-    <Compile Include="Manipulation\SubstituteSubTreeManipulation.cs" />
-    <Compile Include="ProbabilisticTreeCreator.cs" />
     <Compile Include="Properties\AssemblyInfo.cs" />
-    <Compile Include="RampedTreeCreator.cs" />
-    <Compile Include="Recombination\LangdonHomologousCrossOver.cs" />
-    <Compile Include="Recombination\OnePointCrossOver.cs" />
-    <Compile Include="Recombination\SizeFairCrossOver.cs" />
-    <Compile Include="Recombination\StandardCrossOver.cs" />
     <Compile Include="TreeGardener.cs" />
   </ItemGroup>
   <ItemGroup>
-    <ProjectReference Include="..\..\HeuristicLab.Constraints\3.2\HeuristicLab.Constraints-3.2.csproj">
-      <Project>{FCD62C6F-4793-4593-AE9A-0BDCA256EE99}</Project>
-      <Name>HeuristicLab.Constraints-3.2</Name>
-    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.Core\3.2\HeuristicLab.Core-3.2.csproj">
       <Project>{F43B59AB-2B8C-4570-BC1E-15592086517C}</Project>
       <Name>HeuristicLab.Core-3.2</Name>
     </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Data\3.2\HeuristicLab.Data-3.2.csproj">
-      <Project>{F473D9AF-3F09-4296-9F28-3C65118DAFFA}</Project>
-      <Name>HeuristicLab.Data-3.2</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Evolutionary\3.2\HeuristicLab.Evolutionary-3.2.csproj">
-      <Project>{F5614C53-153C-4A37-A608-121E1C087F07}</Project>
-      <Name>HeuristicLab.Evolutionary-3.2</Name>
-    </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Operators\3.2\HeuristicLab.Operators-3.2.csproj">
-      <Project>{A9983BA2-B3B2-475E-8E2C-62050B71D1C5}</Project>
-      <Name>HeuristicLab.Operators-3.2</Name>
+    <ProjectReference Include="..\..\HeuristicLab.GP.Interfaces\3.3\HeuristicLab.GP.Interfaces-3.3.csproj">
+      <Project>{924B6BEA-9A99-40FE-9334-5C01E8D540EC}</Project>
+      <Name>HeuristicLab.GP.Interfaces-3.3</Name>
     </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.PluginInfrastructure\HeuristicLab.PluginInfrastructure.csproj">
@@ -156,17 +126,11 @@
       <Name>HeuristicLab.Random-3.2</Name>
     </ProjectReference>
-    <ProjectReference Include="..\..\HeuristicLab.Selection\3.2\HeuristicLab.Selection-3.2.csproj">
-      <Project>{F7CF0571-25CB-43D5-8443-0843A1E2861A}</Project>
-      <Name>HeuristicLab.Selection-3.2</Name>
-    </ProjectReference>
   </ItemGroup>
   <ItemGroup>
-    <EmbeddedResource Include="FunctionView.resx">
-      <DependentUpon>FunctionView.cs</DependentUpon>
-      <SubType>Designer</SubType>
+    <EmbeddedResource Include="FunctionLibraryEditor.resx">
+      <DependentUpon>FunctionLibraryEditor.cs</DependentUpon>
     </EmbeddedResource>
-    <EmbeddedResource Include="GPOperatorLibraryEditor.resx">
-      <DependentUpon>GPOperatorLibraryEditor.cs</DependentUpon>
-      <SubType>Designer</SubType>
+    <EmbeddedResource Include="FunctionTreeView.resx">
+      <DependentUpon>FunctionTreeView.cs</DependentUpon>
     </EmbeddedResource>
   </ItemGroup>
Index: /trunk/sources/HeuristicLab.GP/3.3/HeuristicLabGPPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.GP/3.3/HeuristicLabGPPlugin.cs	(revision 2221)
+++ /trunk/sources/HeuristicLab.GP/3.3/HeuristicLabGPPlugin.cs	(revision 2222)
@@ -28,11 +28,6 @@
   [ClassInfo(Name = "HeuristicLab.GP-3.3")]
   [PluginFile(Filename = "HeuristicLab.GP-3.3.dll", Filetype = PluginFileType.Assembly)]
-  [Dependency(Dependency = "HeuristicLab.Constraints-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Core-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Data-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Evolutionary-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Operators-3.2")]
+  [Dependency(Dependency = "HeuristicLab.GP.Interfaces-3.3")]
   [Dependency(Dependency = "HeuristicLab.Random-3.2")]
-  [Dependency(Dependency = "HeuristicLab.Selection-3.2")]
   public class HeuristicLabGPPlugin : PluginBase {
   }
Index: /trunk/sources/HeuristicLab.GP/3.3/TreeGardener.cs
===================================================================
--- /trunk/sources/HeuristicLab.GP/3.3/TreeGardener.cs	(revision 2221)
+++ /trunk/sources/HeuristicLab.GP/3.3/TreeGardener.cs	(revision 2222)
@@ -22,33 +22,27 @@
 using System;
 using System.Collections.Generic;
-using System.Text;
 using HeuristicLab.Core;
-using HeuristicLab.Constraints;
-using System.Diagnostics;
-using HeuristicLab.Data;
 using System.Linq;
-using HeuristicLab.Random;
-using HeuristicLab.Operators;
 using System.Collections;
-using HeuristicLab.Selection;
+using HeuristicLab.GP.Interfaces;
 
 namespace HeuristicLab.GP {
-  internal class TreeGardener {
+  public class TreeGardener {
     private IRandom random;
-    private GPOperatorLibrary funLibrary;
+    private FunctionLibrary funLibrary;
     private List<IFunction> functions;
 
     private List<IFunction> terminals;
-    internal IList<IFunction> Terminals {
+    public IList<IFunction> Terminals {
       get { return terminals; }
     }
 
     private List<IFunction> allFunctions;
-    internal IList<IFunction> AllFunctions {
+    public IList<IFunction> AllFunctions {
       get { return allFunctions; }
     }
 
     #region constructors
-    internal TreeGardener(IRandom random, GPOperatorLibrary funLibrary) {
+    public TreeGardener(IRandom random, FunctionLibrary funLibrary) {
       this.random = random;
       this.funLibrary = funLibrary;
@@ -57,6 +51,6 @@
       functions = new List<IFunction>();
       // init functions and terminals based on constraints
-      foreach(IFunction fun in funLibrary.Group.Operators) {
-        if(fun.MaxArity == 0) {
+      foreach(IFunction fun in funLibrary.Functions) {
+        if(fun.MaxSubTrees == 0) {
           terminals.Add(fun);
           allFunctions.Add(fun);
@@ -77,5 +71,5 @@
     /// <param name="maxTreeHeight">Maximal height of the tree.</param>
     /// <returns></returns>
-    internal IFunctionTree CreateBalancedRandomTree(int maxTreeSize, int maxTreeHeight) {
+    public IFunctionTree CreateBalancedRandomTree(int maxTreeSize, int maxTreeHeight) {
       IFunction rootFunction = GetRandomRoot(maxTreeSize, maxTreeHeight);
       IFunctionTree tree = MakeBalancedTree(rootFunction, maxTreeHeight - 1);
@@ -90,5 +84,5 @@
     /// <param name="maxTreeHeight">Maximal height of the tree.</param>
     /// <returns></returns>
-    internal IFunctionTree CreateUnbalancedRandomTree(int maxTreeSize, int maxTreeHeight) {
+    public IFunctionTree CreateUnbalancedRandomTree(int maxTreeSize, int maxTreeHeight) {
       IFunction rootFunction = GetRandomRoot(maxTreeSize, maxTreeHeight);
       IFunctionTree tree = MakeUnbalancedTree(rootFunction, maxTreeHeight - 1);
@@ -96,22 +90,22 @@
     }
 
-    internal IFunctionTree PTC2(IRandom random, int size, int maxDepth) {
-      return PTC2(random, GetRandomRoot(size, maxDepth), size, maxDepth);
-    }
-
-    internal IFunctionTree PTC2(IRandom random, IFunction rootF, int size, int maxDepth) {
-      IFunctionTree root = rootF.GetTreeNode();
-      if(size <= 1 || maxDepth <= 1) return root;
+    public IFunctionTree PTC2(int size, int maxDepth) {
+      return PTC2(GetRandomRoot(size, maxDepth), size, maxDepth);
+    }
+
+    private IFunctionTree PTC2(IFunction rootFunction, int size, int maxDepth) {
+      IFunctionTree root = rootFunction.GetTreeNode();
+      if (size <= 1 || maxDepth <= 1) return root;
       List<object[]> list = new List<object[]>();
       int currentSize = 1;
       int totalListMinSize = 0;
-      int minArity = root.Function.MinArity;
-      int maxArity = root.Function.MaxArity;
-      if(maxArity >= size) {
+      int minArity = root.Function.MinSubTrees;
+      int maxArity = root.Function.MaxSubTrees;
+      if (maxArity >= size) {
         maxArity = size;
       }
       int actualArity = random.Next(minArity, maxArity + 1);
-      totalListMinSize += GetMinimalTreeSize(root.Function) - 1;
-      for(int i = 0; i < actualArity; i++) {
+      totalListMinSize += root.Function.MinTreeSize - 1;
+      for (int i = 0; i < actualArity; i++) {
         // insert a dummy sub-tree and add the pending extension to the list
         root.AddSubTree(null);
@@ -119,5 +113,5 @@
       }
 
-      while(list.Count > 0 && totalListMinSize + currentSize < size) {
+      while (list.Count > 0 && totalListMinSize + currentSize < size) {
         int randomIndex = random.Next(list.Count);
         object[] nextExtension = list[randomIndex];
@@ -126,13 +120,13 @@
         int a = (int)nextExtension[1];
         int d = (int)nextExtension[2];
-        if(d == maxDepth) {
+        if (d == maxDepth) {
           parent.RemoveSubTree(a);
           IFunctionTree branch = CreateRandomTree(GetAllowedSubFunctions(parent.Function, a), 1, 1);
           parent.InsertSubTree(a, branch); // insert a smallest possible tree
-          currentSize += branch.Size;
-          totalListMinSize -= branch.Size;
+          currentSize += branch.GetSize();
+          totalListMinSize -= branch.GetSize();
         } else {
-          IFunction selectedFunction = RandomSelect(GetAllowedSubFunctions(parent.Function, a).Where(
-            f => !IsTerminal(f) && GetMinimalTreeHeight(f) + (d - 1) <= maxDepth).ToArray());
+          IFunction selectedFunction = TreeGardener.RandomSelect(random, GetAllowedSubFunctions(parent.Function, a).Where(
+            f => !TreeGardener.IsTerminal(f) && f.MinTreeHeight + (d - 1) <= maxDepth).ToArray());
           IFunctionTree newTree = selectedFunction.GetTreeNode();
           parent.RemoveSubTree(a);
@@ -141,19 +135,19 @@
           totalListMinSize--;
 
-          minArity = selectedFunction.MinArity;
-          maxArity = selectedFunction.MaxArity;
-          if(maxArity >= size) {
+          minArity = selectedFunction.MinSubTrees;
+          maxArity = selectedFunction.MaxSubTrees;
+          if (maxArity >= size) {
             maxArity = size;
           }
           actualArity = random.Next(minArity, maxArity + 1);
-          for(int i = 0; i < actualArity; i++) {
+          for (int i = 0; i < actualArity; i++) {
             // insert a dummy sub-tree and add the pending extension to the list
             newTree.AddSubTree(null);
             list.Add(new object[] { newTree, i, d + 1 });
           }
-          totalListMinSize += GetMinimalTreeSize(newTree.Function) - 1;
-        }
-      }
-      while(list.Count > 0) {
+          totalListMinSize += newTree.Function.MinTreeSize - 1;
+        }
+      }
+      while (list.Count > 0) {
         int randomIndex = random.Next(list.Count);
         object[] nextExtension = list[randomIndex];
@@ -168,5 +162,5 @@
       return root;
     }
-
+ 
     /// <summary>
     /// selects a random function from allowedFunctions and creates a random (unbalanced) tree with maximal size and height.
@@ -176,11 +170,11 @@
     /// <param name="maxTreeHeight">Maximal height of the tree.</param>
     /// <returns>New random unbalanced tree</returns>
-    internal IFunctionTree CreateRandomTree(ICollection<IFunction> allowedFunctions, int maxTreeSize, int maxTreeHeight) {
+    public IFunctionTree CreateRandomTree(ICollection<IFunction> allowedFunctions, int maxTreeSize, int maxTreeHeight) {
       // get the minimal needed height based on allowed functions and extend the max-height if necessary
-      int minTreeHeight = allowedFunctions.Select(f => GetMinimalTreeHeight(f)).Min();
+      int minTreeHeight = allowedFunctions.Select(f => f.MinTreeHeight).Min();
       if(minTreeHeight > maxTreeHeight)
         maxTreeHeight = minTreeHeight;
       // get the minimal needed size based on allowed functions and extend the max-size if necessary
-      int minTreeSize = allowedFunctions.Select(f => GetMinimalTreeSize(f)).Min();
+      int minTreeSize = allowedFunctions.Select(f => f.MinTreeSize).Min();
       if(minTreeSize > maxTreeSize)
         maxTreeSize = minTreeSize;
@@ -191,45 +185,17 @@
 
       // filter the set of allowed functions and select only from those that fit into the given maximal size and height limits
-      IFunction[] possibleFunctions = allowedFunctions.Where(f => GetMinimalTreeHeight(f) <= treeHeight &&
-        GetMinimalTreeSize(f) <= treeSize).ToArray();
+      IFunction[] possibleFunctions = allowedFunctions.Where(f => f.MinTreeHeight <= treeHeight &&
+        f.MinTreeSize <= treeSize).ToArray();
       IFunction selectedFunction = RandomSelect(possibleFunctions);
 
       // build the tree 
       IFunctionTree root;
-      root = PTC2(random, selectedFunction, maxTreeSize, maxTreeHeight);
+      root = PTC2(selectedFunction, maxTreeSize, maxTreeHeight);
       return root;
     }
-
-    internal CompositeOperation CreateInitializationOperation(ICollection<IFunctionTree> trees, IScope scope) {
-      // needed for the parameter shaking operation
-      CompositeOperation initializationOperation = new CompositeOperation();
-      Scope tempScope = new Scope("Temp. initialization scope");
-
-      var parametricTrees = trees.Where(t => t.Function.GetVariable(FunctionBase.INITIALIZATION) != null);
-      foreach(IFunctionTree tree in parametricTrees) {
-        // enqueue an initialization operation for each operator with local variables 
-        IOperator initialization = (IOperator)tree.Function.GetVariable(FunctionBase.INITIALIZATION).Value;
-        Scope initScope = new Scope();
-        // copy the local variables into a temporary scope used for initialization
-        foreach(IVariable variable in tree.LocalVariables) {
-          initScope.AddVariable(variable);
-        }
-        tempScope.AddSubScope(initScope);
-        initializationOperation.AddOperation(new AtomicOperation(initialization, initScope));
-      }
-      Scope backupScope = new Scope("backup");
-      foreach(Scope subScope in scope.SubScopes) {
-        backupScope.AddSubScope(subScope);
-      }
-      scope.AddSubScope(tempScope);
-      scope.AddSubScope(backupScope);
-      // add an operation to remove the temporary scopes        
-      initializationOperation.AddOperation(new AtomicOperation(new RightReducer(), scope));
-      return initializationOperation;
-    }
     #endregion
 
     #region tree information gathering
-    internal IFunctionTree GetRandomParentNode(IFunctionTree tree) {
+    public IFunctionTree GetRandomParentNode(IFunctionTree tree) {
       List<IFunctionTree> parentNodes = new List<IFunctionTree>();
 
@@ -246,5 +212,5 @@
     }
 
-    internal ICollection<IFunctionTree> GetAllSubTrees(IFunctionTree root) {
+    public static ICollection<IFunctionTree> GetAllSubTrees(IFunctionTree root) {
       List<IFunctionTree> allTrees = new List<IFunctionTree>();
       TreeForEach(root, t => { allTrees.Add(t); });
@@ -262,5 +228,5 @@
     /// <param name="branch">branch that is searched in the tree</param>
     /// <returns></returns>
-    internal int GetBranchLevel(IFunctionTree tree, IFunctionTree branch) {
+    public int GetBranchLevel(IFunctionTree tree, IFunctionTree branch) {
       return GetBranchLevelHelper(tree, branch, 1);
     }
@@ -278,10 +244,10 @@
     }
 
-    internal bool IsValidTree(IFunctionTree tree) {
+    public bool IsValidTree(IFunctionTree tree) {
       for(int i = 0; i < tree.SubTrees.Count; i++) {
-        if(!tree.Function.AllowedSubFunctions(i).Contains(tree.SubTrees[i].Function)) return false;
-      }
-
-      if(tree.SubTrees.Count < tree.Function.MinArity || tree.SubTrees.Count > tree.Function.MaxArity)
+        if(!tree.Function.GetAllowedSubFunctions(i).Contains(tree.SubTrees[i].Function)) return false;
+      }
+
+      if(tree.SubTrees.Count < tree.Function.MinSubTrees || tree.SubTrees.Count > tree.Function.MaxSubTrees)
         return false;
       foreach(IFunctionTree subTree in tree.SubTrees) {
@@ -292,5 +258,5 @@
 
     // returns a random branch from the specified level in the tree
-    internal IFunctionTree GetRandomBranch(IFunctionTree tree, int level) {
+    public IFunctionTree GetRandomBranch(IFunctionTree tree, int level) {
       if(level == 0) return tree;
       List<IFunctionTree> branches = new List<IFunctionTree>();
@@ -312,6 +278,6 @@
 
     private bool IsPossibleParent(IFunction f, List<IFunction> children) {
-      int minArity = f.MinArity;
-      int maxArity = f.MaxArity;
+      int minArity = f.MinSubTrees;
+      int maxArity = f.MaxSubTrees;
       // note: we can't assume that the operators in the children list have different types!
 
@@ -329,5 +295,5 @@
       // we only count those slots that can hold at least one of the children that we should combine
       for(int slot = 0; slot < nSlots; slot++) {
-        HashSet<IFunction> functionSet = new HashSet<IFunction>(f.AllowedSubFunctions(slot));
+        HashSet<IFunction> functionSet = new HashSet<IFunction>(f.GetAllowedSubFunctions(slot));
         if(functionSet.Count() > 0) {
           slotSets.Add(functionSet);
@@ -365,5 +331,5 @@
       return assignments == children.Count - 1;
     }
-    internal IList<IFunction> GetAllowedParents(IFunction child, int childIndex) {
+    public IList<IFunction> GetAllowedParents(IFunction child, int childIndex) {
       List<IFunction> parents = new List<IFunction>();
       foreach(IFunction function in functions) {
@@ -375,12 +341,12 @@
       return parents;
     }
-    internal bool IsTerminal(IFunction f) {
-      return f.MinArity == 0 && f.MaxArity == 0;
-    }
-    internal IList<IFunction> GetAllowedSubFunctions(IFunction f, int index) {
+    public static bool IsTerminal(IFunction f) {
+      return f.MinSubTrees == 0 && f.MaxSubTrees == 0;
+    }
+    public ICollection<IFunction> GetAllowedSubFunctions(IFunction f, int index) {
       if(f == null) {
         return allFunctions;
       } else {
-        return f.AllowedSubFunctions(index);
+        return f.GetAllowedSubFunctions(index);
       }
     }
@@ -388,11 +354,11 @@
 
     #region private utility methods
-    private IFunction GetRandomRoot(int maxTreeSize, int maxTreeHeight) {
+    public IFunction GetRandomRoot(int maxTreeSize, int maxTreeHeight) {
       if(maxTreeHeight == 1 || maxTreeSize == 1) {
         IFunction selectedTerminal = RandomSelect(terminals);
         return selectedTerminal;
       } else {
-        IFunction[] possibleFunctions = functions.Where(f => GetMinimalTreeHeight(f) <= maxTreeHeight &&
-          GetMinimalTreeSize(f) <= maxTreeSize).ToArray();
+        IFunction[] possibleFunctions = functions.Where(f => f.MinTreeHeight <= maxTreeHeight &&
+          f.MinTreeSize <= maxTreeSize).ToArray();
         IFunction selectedFunction = RandomSelect(possibleFunctions);
         return selectedFunction;
@@ -403,11 +369,11 @@
     private IFunctionTree MakeUnbalancedTree(IFunction parent, int maxTreeHeight) {
       if(maxTreeHeight == 0) return parent.GetTreeNode();
-      int minArity = parent.MinArity;
-      int maxArity = parent.MaxArity;
+      int minArity = parent.MinSubTrees;
+      int maxArity = parent.MaxSubTrees;
       int actualArity = random.Next(minArity, maxArity + 1);
       if(actualArity > 0) {
         IFunctionTree parentTree = parent.GetTreeNode();
         for(int i = 0; i < actualArity; i++) {
-          IFunction[] possibleFunctions = GetAllowedSubFunctions(parent, i).Where(f => GetMinimalTreeHeight(f) <= maxTreeHeight).ToArray();
+          IFunction[] possibleFunctions = GetAllowedSubFunctions(parent, i).Where(f => f.MinTreeHeight <= maxTreeHeight).ToArray();
           IFunction selectedFunction = RandomSelect(possibleFunctions);
           IFunctionTree newSubTree = MakeUnbalancedTree(selectedFunction, maxTreeHeight - 1);
@@ -424,6 +390,6 @@
     private IFunctionTree MakeBalancedTree(IFunction parent, int maxTreeHeight) {
       if(maxTreeHeight == 0) return parent.GetTreeNode();
-      int minArity = parent.MinArity;
-      int maxArity = parent.MaxArity;
+      int minArity = parent.MinSubTrees;
+      int maxArity = parent.MaxSubTrees;
       int actualArity = random.Next(minArity, maxArity + 1);
       if(actualArity > 0) {
@@ -431,5 +397,5 @@
         for(int i = 0; i < actualArity; i++) {
           // first try to find a function that fits into the maxHeight limit
-          IFunction[] possibleFunctions = GetAllowedSubFunctions(parent, i).Where(f => GetMinimalTreeHeight(f) <= maxTreeHeight &&
+          IFunction[] possibleFunctions = GetAllowedSubFunctions(parent, i).Where(f => f.MinTreeHeight <= maxTreeHeight &&
             !IsTerminal(f)).ToArray();
           // no possible function found => extend function set to terminals
@@ -450,13 +416,5 @@
     }
 
-    private int GetMinimalTreeHeight(IOperator op) {
-      return ((IntData)op.GetVariable(GPOperatorLibrary.MIN_TREE_HEIGHT).Value).Data;
-    }
-
-    private int GetMinimalTreeSize(IOperator op) {
-      return ((IntData)op.GetVariable(GPOperatorLibrary.MIN_TREE_SIZE).Value).Data;
-    }
-
-    private void TreeForEach(IFunctionTree tree, Action<IFunctionTree> action) {
+    private static void TreeForEach(IFunctionTree tree, Action<IFunctionTree> action) {
       action(tree);
       foreach(IFunctionTree subTree in tree.SubTrees) {
@@ -465,8 +423,8 @@
     }
 
-    private void GetBranchesAtLevel(IFunctionTree tree, int level, List<IFunctionTree> result) {
+    private static void GetBranchesAtLevel(IFunctionTree tree, int level, List<IFunctionTree> result) {
       if(level == 1) result.AddRange(tree.SubTrees);
       foreach(IFunctionTree subTree in tree.SubTrees) {
-        if(subTree.Height >= level - 1)
+        if(subTree.GetHeight() >= level - 1)
           GetBranchesAtLevel(subTree, level - 1, result);
       }
@@ -474,10 +432,14 @@
 
     private IFunction RandomSelect(IList<IFunction> functionSet) {
+      return RandomSelect(random, functionSet);
+    }
+
+    public static IFunction RandomSelect(IRandom random, IList<IFunction> functionSet) {
       double[] accumulatedTickets = new double[functionSet.Count];
       double ticketAccumulator = 0;
       int i = 0;
       // precalculate the slot-sizes
-      foreach(IFunction function in functionSet) {
-        ticketAccumulator += ((DoubleData)function.GetVariable(GPOperatorLibrary.TICKETS).Value).Data;
+      foreach (IFunction function in functionSet) {
+        ticketAccumulator += function.Tickets;
         accumulatedTickets[i] = ticketAccumulator;
         i++;
@@ -486,6 +448,6 @@
       double r = random.NextDouble() * ticketAccumulator;
       // find the slot that has been hit
-      for(i = 0; i < accumulatedTickets.Length; i++) {
-        if(r < accumulatedTickets[i]) return functionSet[i];
+      for (i = 0; i < accumulatedTickets.Length; i++) {
+        if (r < accumulatedTickets[i]) return functionSet[i];
       }
       // sanity check
Index: /trunk/sources/HeuristicLab.LinearRegression/3.2/HeuristicLab.LinearRegression-3.2.csproj
===================================================================
--- /trunk/sources/HeuristicLab.LinearRegression/3.2/HeuristicLab.LinearRegression-3.2.csproj	(revision 2221)
+++ /trunk/sources/HeuristicLab.LinearRegression/3.2/HeuristicLab.LinearRegression-3.2.csproj	(revision 2222)
@@ -113,4 +113,8 @@
       <Name>HeuristicLab.Data-3.2</Name>
     </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.GP.Interfaces\3.3\HeuristicLab.GP.Interfaces-3.3.csproj">
+      <Project>{924B6BEA-9A99-40FE-9334-5C01E8D540EC}</Project>
+      <Name>HeuristicLab.GP.Interfaces-3.3</Name>
+    </ProjectReference>
     <ProjectReference Include="..\..\HeuristicLab.GP.StructureIdentification\3.3\HeuristicLab.GP.StructureIdentification-3.3.csproj">
       <Project>{74223A32-C726-4978-BE78-37113A18373C}</Project>
Index: /trunk/sources/HeuristicLab.LinearRegression/3.2/HeuristicLabLinearRegressionPlugin.cs
===================================================================
--- /trunk/sources/HeuristicLab.LinearRegression/3.2/HeuristicLabLinearRegressionPlugin.cs	(revision 2221)
+++ /trunk/sources/HeuristicLab.LinearRegression/3.2/HeuristicLabLinearRegressionPlugin.cs	(revision 2222)
@@ -32,4 +32,5 @@
   [Dependency(Dependency = "HeuristicLab.DataAnalysis-3.2")]
   [Dependency(Dependency = "HeuristicLab.GP-3.3")]
+  [Dependency(Dependency = "HeuristicLab.GP.Interfaces-3.3")]
   [Dependency(Dependency = "HeuristicLab.GP.StructureIdentification-3.3")]
   [Dependency(Dependency = "HeuristicLab.Modeling-3.2")]
